require 'fluent/plugin/graphite'
require 'fluent/plugin/filter'

module Fluent::Plugin
  class GraphiteFilter < Fluent::Plugin::Filter
    Fluent::Plugin.register_filter('graphite', self)
    include Fluent::Plugin::Graphite

    config_param :host, :string
    config_param :port, :integer, default: 2003
    config_param :prefix, :string, default: 'adp-fluentd-agent'
    config_param :monitoring_key, :string
    config_param :max_retries, :integer, default: 3
    config_param :log_level, :string, default: 'info'

    def start
      super
      init_client(@log_level, @host, @port)
    end

    def configure(conf)
      super
    end

    def filter(tag, time, record)
      metrics = format_metrics(tag, record)
      post(metrics, time)
      record
    end
  end
end
