require 'fluent/plugin/graphite'
require 'fluent/plugin/output'

module Fluent::Plugin
  class GraphiteOutput < Fluent::Plugin::Output
    Fluent::Plugin.register_output('graphite', self)
    include Fluent::Plugin::Graphite

    config_param :host, :string
    config_param :port, :integer, default: 2003
    config_param :prefix, :string, default: 'adp-fluentd-agent'
    config_param :monitoring_key, :string
    config_param :max_retries, :integer, default: 3
    config_param :log_level, :string, default: 'info'

    def start
      super
      init_client(@log_level, @host, @port)
    end

    def configure(conf)
      super
    end

    def process(tag, es)
      es.each do |time, record|
        emit_tag = tag.dup
        metrics = format_metrics(emit_tag, record)

        # implemented to immediate call post method in this loop, because graphite-api.gem has the buffers.
        post(metrics, time)
      end

    end

  end
end
